#include "meinMinElement.h"

template <typename Iter>
Iter MeinMinElement(Iter beg, Iter end)
{
   if (beg == end)
   {
      return end;
   }
   Iter res = beg;
   while (++beg != end)
   {
      if (*beg < *res)
      {
         res = beg;
      }
   }
   return res;
}


template <typename Iter, typename Typ>
Iter MeinMinElementUngleich(Iter beg, Iter end, Typ wert)
{
   if (beg == end)
   {
      return end;
   }
   // find the first instance which is differnt from wert
   Iter res = beg;
   while (res != end && *res == wert)
   {
      ++res;
   }

   // res now points to the current minima from [beg..res]

   // before res everything is equal to wert
   beg = res;
   // now loop over the rest of the interval and try to find a smaller minima
   // which is different from wert
   while (beg != end)
   {
      if (*beg < *res && *beg != wert)
      {
         res = beg;
      }
      ++beg;
   }
   return (*res!= wert ? res : end);
}

